Name:    opa-ff
Version: 10.0.0.0
Release: 440.0.1%{?dist}.AXS7
Summary: Intel Omni-Path basic tools and libraries for fabric management
Group: System Environment/Libraries
License: BSD
Url: https://github.com/01org/opa-ff
# tarball created by:
# git clone https://github.com/01org/opa-ff.git
# cd opa-ff
# git archive --format=tar --prefix=opa-ff/ c9ccf1560befcf8e3860820a52045b811f4372a0 | xz > opa-ff.tar.xz
Source: %{name}.tar.xz

Patch0001: 0001-Fix-scripts-that-use-well-known-temp-files.patch

# Asianux
Patch0100: set_vendor_file_to_redhat.patch

BuildRequires: autoconf, automake
BuildRequires: zlib-devel, openssl-devel, tcl-devel, ncurses-devel
BuildRequires: libibumad-devel, libibverbs-devel, libibmad-devel, ibacm-devel, expat-devel

ExclusiveArch: x86_64

%description
Intel Omni-Path basic tools and libraries for fabric management.

%package -n opa-basic-tools
Summary: OPA management level tools and scripts
Group: System Environment/Libraries

%description -n opa-basic-tools
Contains basic tools for fabric management necessary on all compute nodes.

%package -n opa-address-resolution
Summary: OPA Address Resolution manager
Group: System Environment/Libraries
Requires: opa-basic-tools%{?_isa} = %{version}-%{release}

%description -n opa-address-resolution
OPA Address Resolution manager.

%prep
%setup -q -n %{name}
%patch0001 -p1

# Asianux
%patch0100 -p1

# Make it possible to override hardcoded compiler flags
sed -i -r -e 's/(release_C(C)?OPT_Flags\s*)=/\1?=/' Makerules/Target.LINUX.GNU.*

# A crude hack from necessity. Upstream hardcodes "/opt/opafm" in many places.
# Packaging guidelines disallow installation into /opt.
# Instead we use /usr/lib/opa-fm/ (NOT _libdir !) as opa-fm's private
# directory.
sed -i -e 's#/opt/opafm#/usr/lib/opa-fm#g' $(grep -r -l '/opt/opafm' .)
# The same holds for opa-ff:
sed -i -e 's#/opt/opa#/usr/lib/opa-ff#g'   $(grep -r -l '/opt/opa' .)

%build
export CFLAGS='%{optflags}'
export CXXFLAGS='%{optflags}'
export release_COPT_Flags='%{optflags}'
export release_CCOPT_Flags='%{optflags}'
./ff_build.sh %{_builddir} $FF_BUILD_ARGS


%install
%define basic_tools_sbin fabric_info opacapture opafequery opagetvf opagetvf_env opahfirev opapacketcapture opaportinfo oparesolvehfiport opasaquery opashowmc opasmaquery opainfo

%define basic_tools_sbin_sym opapmaquery opaportconfig

%define basic_tools_opt setup_self_ssh usemem opaipcalc

%define basic_mans opacapture.1 opaconfig.1 opadisablehosts.1 opadisableports.1 opadownloadall.1 opahfirev.1 opapaquery.1 opapmaquery.1 opaportconfig.1 opaportinfo.1 oparesolvehfiport.1 opasaquery.1 opashowmc.1 opasmaquery.1

%define opasadb_bin opa_osd_dump opa_osd_exercise opa_osd_perf opa_osd_query

%define opasadb_header opasadb_path.h opasadb_route.h opasadb_route2.h

%define release_string IntelOPA-Tools-FF.$BUILD_TARGET_OS_ID.$MODULEVERSION

#rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{_bindir}
mkdir -p $RPM_BUILD_ROOT%{_sbindir}
mkdir -p $RPM_BUILD_ROOT/usr/lib/opa-ff/{tools,fm_tools,help,samples,src/mpi_apps}
mkdir -p $RPM_BUILD_ROOT%{_libdir}/ibacm
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/rdma
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/opa
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/opa
mkdir -p $RPM_BUILD_ROOT%{_includedir}/infiniband
mkdir -p $RPM_BUILD_ROOT%{_mandir}/man1
mkdir -p $RPM_BUILD_ROOT%{_mandir}/man8


#Binaries and scripts installing (basic tools)
#cd builtbin.OPENIB_FF.release
cd $(cat %{_builddir}/RELEASE_PATH)

cd bin
cp -t $RPM_BUILD_ROOT%{_sbindir} %basic_tools_sbin 
cp -t $RPM_BUILD_ROOT/usr/lib/opa-ff/tools/ %basic_tools_opt
ln -s ./opaportinfo $RPM_BUILD_ROOT%{_sbindir}/opaportconfig
ln -s ./opasmaquery $RPM_BUILD_ROOT%{_sbindir}/opapmaquery

cd ../opasadb
cp -t $RPM_BUILD_ROOT%{_bindir} %opasadb_bin
cp -t $RPM_BUILD_ROOT%{_includedir}/infiniband %opasadb_header

cd ../man/man1
cp -t $RPM_BUILD_ROOT%{_mandir}/man1 %basic_mans
cd ..

#Config files
cd ../config
cp -t $RPM_BUILD_ROOT%{_sysconfdir}/rdma dsap.conf

#Libraries installing
#cd ../builtlibs.OPENIB_FF.release
cd $(cat %{_builddir}/LIB_PATH)
cp -t $RPM_BUILD_ROOT%{_libdir} libopasadb.so.*
cp -t $RPM_BUILD_ROOT%{_libdir}/ibacm libdsap.so.*

#Now we do a bunch of work to build the file listing of what belongs to each RPM

#Basic tools sbin
echo "%{_sbindir}/%{basic_tools_sbin} %{basic_tools_sbin_sym}" > %{_builddir}/basic_sbin_file.list
sed -i 's;[ ];\n%{_sbindir}/;g' %{_builddir}/basic_sbin_file.list 

#Basic tools opt
echo "/usr/lib/opa-ff/tools/%{basic_tools_opt}" > %{_builddir}/basic_opt_file.list
sed -i 's;[ ];\n/usr/lib/opa-ff/tools/;g' %{_builddir}/basic_opt_file.list 

#Basic man pages
echo "/usr/share/man/man1/%{basic_mans}" > %{_builddir}/basic_mans.list
sed -i 's;[ ];\n/usr/share/man/man1/;g' %{_builddir}/basic_mans.list
sed -i 's;\.1;\.1*;g' %{_builddir}/basic_mans.list

#Final file listing for 'basic'
cat %{_builddir}/basic_sbin_file.list %{_builddir}/basic_opt_file.list %{_builddir}/basic_mans.list > %{_builddir}/basic_file.list

%post -n opa-address-resolution -p /sbin/ldconfig
%postun -n opa-address-resolution -p /sbin/ldconfig

%files -n opa-basic-tools -f %{_builddir}/basic_file.list
%doc LICENSE

%files -n opa-address-resolution
%doc LICENSE
#Everything under the bin directory belongs exclusively to opasadb at this time.
%{_bindir}/*
%{_libdir}/*
%{_includedir}/*
%config(noreplace) %{_sysconfdir}/rdma/dsap.conf

%changelog
* Fri Nov 11 2015 Tom Cao <tom.cao@asianux.com> - 10.0.0.0-440.0.1
- Set os vendor file to redhat-release

* Mon Sep 28 2015 Honggang Li <honli@redhat.com> - 10.0.0.0-440
- Fix scripts that use well-known temp files
- Related: bz1262326

* Wed Sep 23 2015 Honggang Li <honli@redhat.com> - 10.0.0.0-439
- Fix various /tmp races
- Resolves: bz1262326

* Tue Sep 15 2015 Michal Schmidt <mschmidt@redhat.com> - 10.0.0.0-438
- Include the LICENSE file in both subpackages.

* Wed Aug 26 2015 Michal Schmidt <mschmidt@redhat.com> - 10.0.0.0-437
- Respect optflags.
- Related: bz1173309

* Tue Aug 25 2015 Michal Schmidt <mschmidt@redhat.com> - 10.0.0.0-436
- Update to new upstream snapshot with unbundled 3rd party software.
- Follow upstream spec file changes.
- Related: bz1173309

* Wed Aug 19 2015 Michal Schmidt <mschmidt@redhat.com> - 10.0.0.0-435
- Initial RHEL package based on upstream spec and input from Honggang Li.

* Fri Oct 10 2014 Erik E. Kahn <erik.kahn@intel.com> - 1.0.0-ifs
- Initial version
